unit glclaux18;
{     A          '
     A\A         '
    A\\\A        '
   AAAAAAA       '
  A\\\\\\\A      '
  \\      \\     '
}
interface
uses glcl18,opengl,sysutils,lists,classes;
type

tglRing = class(tglList)
INRrad,OUTrad,h : single;
flatout : boolean;
constructor create(aid : smallint;x,y,z : single;InnerRadius,outterradius,height : single;outCutOff : boolean);
procedure   showself2;override;
end;

tglButtonBar = class(tglButton)
function  hclick(xc,yc,zc : single;sh : tshiftstate) : boolean;override;
end;

tglReflector = class(tglCUbe)//fucky
procedure processlist;override;
end;

tglScaler = class(tglobj)
xf,yf,zf : single;
constructor create(aid : smallint;x,y,z,axf,ayf,azf : single);
procedure beginshow;override;
end;

tglHandler = class(tglObj)
ev : tnotifyevent;
dta : pointer;
constructor create(aid : smallint;eve : tnotifyevent);
procedure   event;virtual;
procedure   selfhandle;virtual;
end;

tglOnShow = class(tglhandler)
procedure showself;override;
end;

tglOnDestroy = class(tglhandler)
destructor destroy;override;
end;

tglblinker = class(tglobj)
curem : single;
low : single;
vector : shortint;
bltime,ltime : double;
constructor create(aid : smallint;r,g,b,u : single;atime : double);
procedure addr(Item : Tlitem);override;
procedure addp(Item : Tlitem);override;
procedure show;override;
procedure beginshow;override;
procedure killall;override;
procedure kill(AID : SMALLINT);override;
end;

tglEnhBlinker = class(tglObj,iglEnhcolor) {V18 blinker using enhcolor}
curem : single;
low : single;
vector : shortint;
bltime,ltime : double;
constructor create(aid : smallint;r,g,b,u : single;atime : double);
procedure addr(Item : Tlitem);override;
procedure addp(Item : Tlitem);override;
procedure show;override;
procedure encolor;virtual;
procedure hidecolor;virtual;
procedure killall;override;
procedure kill(AID : SMALLINT);override;
end;

tglemifader = class(tglblinker)
autodestroy : boolean;
constructor create(aid : smallint;r,g,b,u : single;atime : double);
procedure show;override;
procedure killall;override;
end;

tglrecolorer = class(tglobj)
starttime,rectime,ltime : double;
recoloring : boolean;
autodestroy : boolean;
constructor create(aid : smallint);
procedure recolorto(r,g,b,u : single;recolortime : double);virtual;
{procedure recolorby(r,g,b,u : smallint);virtual;}
procedure show;override;
procedure killall;override;
end;


tglAnYcolor = class(tglrecolorer)
tocol : floatar4;
mnsum,mxsum : single;
constructor create(aid : smallint;recolortime : double;minsum,maxsum : single);
procedure show;override;
end;

tglresizer = class(tglobj)
starttime,retime,ltime : double;
resizing : boolean;
autodestroy : boolean;
constructor create(aid : smallint);
procedure resizeto(size : single;resizetime : double);virtual;
procedure show;override;
procedure killall;override;
end;

tglshaker = class(tglmover)
procedure show;override;
end;

tglAnyMove = class(tglMOver)
rx,ry,rz,rxr,ryr,rzr : single;
tm : double;
constructor create(aid : smallint;arx,ary,arz,arxr,aryr,arzr : single;movt : double);
procedure callany;virtual;
procedure show;override;
end;

tglSpeedPoint = class(tglmover)
size : single;
constructor create(aid : smallint;x,y,z,a : single);
procedure show;override;
end;

procedure MoveGlObj(fromobj,toobj : tglobj;aid : smallint);
procedure RenameGlObj(fromobj : tglobj;aid,newid : smallint);

procedure xglRing(inrrad,outrad,h : single;sl : integer;flatout : boolean);
procedure xglCone(h,r : single;sl : integer;b : boolean;smsh : boolean);

procedure strsize(const str : string;const fnt : tglFont;const xf,yf : single;var xsz,ysz : single);
procedure wrpstr(var str : string;const fnt : tglFont;var xf,yf : single;const XSZ,YSZ : single;const stretch : boolean);

procedure clamprotate(o : tglobj);

const
{COLORZ}
glclRed    : floatar4 = (0.8,0.2,0.2,1);
glclGreen  : floatar4 = (0.2,0.8,0.2,1);
glclBlue   : floatar4 = (0.2,0.2,0.8,1);
glclYellow : floatar4 = (0.8,0.8,0.2,1);
glclPink   : floatar4 = (0.7,0.4,0.4,1);
glclWhite  : floatar4 = (1  ,1  ,1  ,1);
glclGray   : floatar4 = (0.5,0.5,0.5,1);
implementation
procedure clamprotate(o : tglobj);
begin
if (o.xr < 0) or (o.xr > 360) then o.xr := o.xr-360*trunc(o.xr/360);
if (o.yr < 0) or (o.yr > 360) then o.yr := o.yr-360*trunc(o.yr/360);
if (o.zr < 0) or (o.zr > 360) then o.zr := o.zr-360*trunc(o.zr/360);
end;
procedure strsize(const str : string;const fnt : tglFont;const xf,yf : single;var xsz,ysz : single);
var shx,shy : single;
x : integer;
begin
shx := 0;shy := 0;
xsz := 0;ysz := 0;
fnt.xt := xf;fnt.yt := yf;
for x := 1 to length(str) do
begin
if shx > xsz then xsz := shx;
if shy > ysz then ysz := shy;
if str[x] = #$D then begin  shx := 0;continue end;   {CR}
if str[x] = #$A then begin  shy := shy-1;continue;end;{LF}
   fnt.charsize(byte(str[x]),shx,shy);
if not fnt.autoshift then shx := shx+1;
end;
if shx > xsz then xsz := shx;
if shy > ysz then ysz := shy;
xsz := xsz*xf;
ysz := ysz*yf;
end;

procedure wrpstr(var str : string;const fnt : tglFont;var xf,yf : single;const XSZ,YSZ : single;const stretch : boolean);
var szx,szy : single;
begin { TODO : implement wrapstring }
strsize(str,fnt,1,1,szx,szy);
xf := szx/XSZ;yf := SZY/YSZ;
end;

constructor tglHandler.create(aid : smallint;eve : tnotifyevent);
begin
inherited create(aid,0,0,0);
ev := eve;
end;

procedure   tglhandler.event;
begin
selfhandle;  ev(self);{ili naoborot???????}
end;


procedure   tglhandler.selfhandle;
begin
end;

destructor tglOndestroy.destroy;
begin
event;
inherited destroy;
end;


procedure tglReflector.processlist;
const matr1 : array[1..4,1..4] of single=
((1,0, 0,0),
 (0,1, 0,0),
 (0,0,-1,0),
 (0,0, 0,1));
 pln : floatar4 = (0,0,1,0);
var
matr : array[1..4,1..4] of single;
begin
move(matr1,matr,4*4*4);
glPushMatrix;
visible := false;
matr[4,3] := zt;
glMultmatrixf(@matr);
glClipPlane(gl_clip_plane0,@pln);
glENable(gl_Clip_plane0);

inherited processlist;
visible := true;
glDisable(gl_Clip_PLane0);
glPopMatrix;
end;

procedure MoveGlObj(fromobj,toobj : tglobj;aid : smallint);
var
p : tlitem;
pl : tptrlitem;
begin
pl := tptrlitem(fromobj.pf.Find(aid));
if pl = nil then exit;
p := pl.ptr;
pl.replica := true;
fromobj.Kill(aid);
toobj.add(p);
end;

procedure RenameGlObj(fromobj : tglobj;aid,newid : smallint);
var
p : tlitem;
pl : tptrlitem;
begin
pl := tptrlitem(fromobj.pf.Find(aid));
if pl = nil then exit;
p := pl.ptr;
pl.replica := true;
fromobj.Kill(aid);
p.id := newid;
fromobj.add(p);
end;

function  tglButtonBar.hclick(xc,yc,zc : single;sh : tshiftstate) : boolean;{no rotate and traNslate !!!}
var p : tptrlitem;
begin
if isbetween(xc,xt,xb) and isbetween(yc,yt,yb) and isBetween(zc,zt,zb)
then begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
   if (not tglobj(p.ptr).destroyed) and (p.ptr is tglButton) then
   begin
    tglbutton(p.ptr).hclick(xc-xt,yc-yt,zc-zt,sh);
   end;
      p := tptrlitem(p.pn);
end;
lsh := sh;
if assigned(onclick) then
onclick(self); hclick := true end
else hclick := false;
end;

constructor tglAnyMove.create(aid : smallint;arx,ary,arz,arxr,aryr,arzr : single;movt : double);
begin
inherited create(aid,0,0,0);
rx := arx;ry := ary;rz := arz; rxr := arxr;rzr := arzr;ryr := aryr;
tm := movt;
callany;
end;

procedure tglANYmove.callany;
begin
startmove(rx*random(100)/100-rx/2-xt,ry*random(100)/100-ry/2-yt,rz*random(100)/100-rz/2-zt,
rxr*random(100)/100-rxr/2-xr,ryr*random(100)/100-ryr/2-yr,rzr*random(100)/100-rzr/2-zr,tm);
end;

procedure tglanymove.show;
var nowt,ps : double;
begin
nowt := curtime;
if (nowt-starttime > movetime) and moving then begin
xt :=xs+ xm;yt :=ys+ ym;zt := zs+zm;
xr := xsr + xrt;yr := ysr + yrt;zr := zsr + zrt;
callany;
end;
if moving then
begin
ps := (nowt-starttime)/movetime;
xt := xs + xm*ps; yt := ys + ym * ps; zt := zs + zm*ps;
xr := xsr + xrt*ps; yr := ysr + yrt * ps; zr := zsr + zrt*ps;
end;

if visible then
begin
beginshow;
showself;
endshow;
end else if moving then changeobjs{DEFAULT};
end;


procedure tglEmiFader.killall;
begin
inherited killall;
end;

constructor tglAnycolor.create(aid : smallint;recolortime : double;minsum,maxsum : single);
begin
inherited create(aid);
rectime := recolortime;
color[3] := 1;
mnsum := minsum;mxsum := maxsum;
 recolorto(random(100)/100,random(100)/100,random(100)/100,1,rectime);
end;

procedure tglAnyCOLOR.show;{ONLY NON VISIBLE RECOLORER IMPLEMENTED}
var p : tptrlitem;
e  : tglobj;
dt : double;
r1,g1,b1,u,u1: single;
begin
if (curtime-starttime > rectime) and (recoloring) then
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 e := tglobj(p.ptr);
  if e.colorenabled then
 begin
e.setcolor(color[0],color[1],color[2],color[3]);
 end;
 p := tptrlitem(p.pn);
 end;
 r1 := random(100)/100;
 g1 := random(100)/100;
 b1 := random(100)/100;
 u := sqrt(sqr(r1)+sqr(g1)+sqr(g1)) ;
 if (u < mnsum ) then
 begin
 u1 := mnsum/u;
 r1 := r1*u1;
 g1 := g1*u1;
 b1 := b1*u1;
 end;
 if (u > mxsum ) then
 begin
 u1 := mxsum/u;
 r1 := r1*u1;
 g1 := g1*u1;
 b1 := b1*u1;
 end;

 recolorto(r1,g1,b1,color[3],rectime);
end;

if recoloring then begin
dt := (curtime-ltime)/((starttime-curtime)+rectime);
if dt > 1 then dt := 0.5;
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 e := tglobj(p.ptr);
 if e.colorenabled then
 begin
e.color[0] := e.color[0]+(color[0] - e.color[0])*dt;
e.color[1] := e.color[1]+(color[1] - e.color[1])*dt;
e.color[2] := e.color[2]+(color[2] - e.color[2])*dt;
e.color[3] := e.color[3]+(color[3] - e.color[3])*dt;
e.setcolor(e.color[0],e.color[1],e.color[2],e.color[3]);

 end;
 p := tptrlitem(p.pn);
 end;
 ltime := curtime;
 end;
end;

procedure tglSpeedPoint.show;
var nowt,ps : double;
begin
nowt := curtime;
if (nowt-starttime > movetime) and moving then begin
xt :=xs+ xm;yt :=ys+ ym;zt := zs+zm;
moving := false;
if not visible then changeobjs;
if autodestroy then destroyed := true;
end;
if moving then
begin
ps := (nowt-starttime)/movetime;
xt := xs + xm*ps; yt := ys + ym * ps; zt := zs + zm*ps;
end;
glbegin(gl_POINTS);
glvertex3f(xt,yt,zt);
glend;
end;


constructor tglSpeedPoint.create(aid : smallint;x,y,z,a : single);
begin
inherited create(aid,x,y,z);
size := a;
end;

constructor tglemifader.create(aid : smallint;r,g,b,u : single;atime : double);
begin
inherited create(aid,r,g,b,u,atime);
autodestroy := true;
end;


procedure tglemifader.show;
var color1 : floatar4;
d : double;
emf : double;
begin
d := curtime-ltime;
emf := d/bltime;
if vector = -1 then emf := 1 - emf;
if (curtime-ltime) > bltime then begin
if autodestroy then destroyed := true;
exit;
end;
if emf < low then emf := low;
color1[0] := color[0]*emf;
color1[1] := color[1]*emf;
color1[2] := color[2]*emf;
color1[3] := color[3]*emf;
glMaterialfv(glclFace,GL_EMISSION,@color1);
glMaterialfv(glclFace,gl_AMBIENT_AND_DIFFUSE,@ablackALPHA);
glMaterialfv(glclFace,GL_SPECULAR,@ABLaCKalPHA);
glpointsize(3);
beginshow;
showself;
endshow;
glMaterialfv(glclFace,GL_EMISSION,@ABLACKALPHA{NILFLOATAR4});
end;




procedure tglresizer.killall;
var
e : tglobj;
p : tptrlitem;
her : pointer;
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 e := tglobj(p.ptr);
   if (e.getinterface(iglresizeable,her)) then
  (e as iglresizeable).setsize(xt);

 p := tptrlitem(p.pn);
 end;
inherited killall;
end;

procedure tglrecolorer.killall;
var p : tptrlitem;
e : tglobj;
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 e := tglobj(p.ptr);
 if e.colorenabled then
 begin
 e.setcolor(color[0],color[1],color[2],color[3]);
 end;
 p := tptrlitem(p.pn);
 end;
inherited killall;
end;

procedure tglshaker.show;
var nowt,ps : double;
begin
nowt := curtime;
if (nowt-starttime > movetime) and moving then begin
xt :=xs+ xm;yt :=ys+ ym;zt := zs+zm;
xr := xsr + xrt;yr := ysr + yrt;zr := zsr + zrt;
moving := false;
if not visible then changeobjs;
if autodestroy then destroyed := true;
startmove(-xm,-ym,-zm,-xrt,-yrt,-zrt,movetime);
end else
if moving then
begin
ps := (nowt-starttime)/movetime;
xt := xs + xm*ps; yt := ys + ym * ps; zt := zs + zm*ps;
xr := xsr + xrt*ps; yr := ysr + yrt * ps; zr := zsr + zrt*ps;
end;
if xr < 0 then xr := xr + 360;
if xr > 360 then xr := xr-360;
if yr < 0 then yr := yr + 360;
if yr > 360 then yr := yr-360;
if zr < 0 then zr := zr + 360;
if zr > 360 then zr := zr-360;
if visible then
begin
beginshow;
endshow;
end else if moving then changeobjs{DEFAULT};
end;


procedure  tglblinker.killall;
var p : tptrlitem;
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 tglobj(P.PTR).visible := true;
 p := tptrlitem(p.pn);
end;
inherited killall;
end;

procedure tglBlinker.kill(aid : SMALLINT);
var p : tglobj;
pp : tptrLITEM;
begin
pp := tptrlitem(pf.find(aid));
if pp = nil then exit;
p := tglobj(pp.ptr);
p.visible := true;
inherited kill(aid);
end;

procedure tglblinker.beginshow;
var p,p1 : tptrlitem;
begin
if destroyed then exit;
glPushmatrix;
gltranslatef(xt,yt,zt);{OBJECT IS ROTATED,and it stayz on its place }
if xr <> 0 then glrotatef(xr,1,0,0);
if yr <> 0 then glrotatef(yr,0,1,0);
if zr <> 0 then glrotatef(zr,0,0,1);

p := tptrlitem(pf.pf);
while p <> nil do
 begin
 if tglobj(p.ptr).destroyed then
 begin
 p1 := tptrlitem(p.pn);
 kill(tglobj(p.ptr).id);
 p := p1;
 end
 else
 begin
 tglobj(P.PTR).visible := true;
 {$IFDEF GLCLINTERF}
(p.ptr as iGlSHOWER).SHOW;
{$ELSE}
 tglobj(p.ptr).SHOW;
 {$ENDIF}
 tglobj(P.PTR).VISIBLE := false;
 p := tptrlitem(p.pn);
 end;
 end;
end;



procedure tglblinker.addr(ITEM : tlitem);
begin
inherited addr(item);
tglobj(item).visible := false;
end;

procedure tglblinker.addp(ITEM : tlitem);
begin
inherited addp(item);
tglobj(item).visible := false;
end;


constructor tglblinker.create(aid : smallint;r,g,b,u : single;atime : double);
begin
inherited create(aid,0,0,0);
vector := -1;
bltime := atime;
ltime := curtime;
low := 0;
setcolor(r,g,b,u);
end;


procedure tglblinker.show;
var color1 : floatar4;
d : double;
emf : double;
begin
glpushattrib(GL_COLOR_MATERIAL);
d := curtime-ltime;
emf := d/bltime;
if vector = -1 then emf := 1 - emf;
if (curtime-ltime) > bltime then begin
ltime := curtime;
vector := -vector;
end;
if emf < low then emf := low;
color1[0] := color[0]*emf;
color1[1] := color[1]*emf;
color1[2] := color[2]*emf;
color1[3] := color[3]*emf;
glMaterialfv(glclFace,GL_EMISSION,@color1);
beginshow;
endshow;
glPOPattrib;
end;

constructor tglresizer.create(aid : smallint);
begin
inherited create(aid,0,0,0);
resizing := false;
autodestroy := false;
end;

procedure tglresizer.resizeto(size : single;resizetime : double);
begin
resizing := true;
xt := size;
retime := resizetime;
ltime := curtime;
starttime := curtime;
end;

procedure tglresizer.show;{ONLY NON VISIBLE RECOLORER IMPLEMENTED}
var p : tptrlitem;
e  : tglobj;
dt : double;
nn : double;
her : pointer;
begin
nn := curtime;
if (nn-starttime > retime) and (resizing) then
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 e := tglobj(p.ptr);
 if (e.getinterface(iglresizeable,her)) then
 (e as iglresizeable).setsize(xt);
 p := tptrlitem(p.pn);
 end;

 if autodestroy then destroyed := true;
resizing := false;
end;
if resizing then begin
dt := (nn-ltime)/((starttime-nn)+retime);
if dt > 1 then dt := 1;
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 e := tglobj(p.ptr);
  if (e.getinterface(iglresizeable,her)) then
  (e as iglresizeable).setsize((e as iglresizeable).getsize+(xt-(e as iglresizeable).getsize)*dt);
 p := tptrlitem(p.pn);
 end;
 ltime := nn;
 end;
end;


constructor tglrecolorer.create(aid : smallint);
begin
inherited create(aid,0,0,0);
recoloring := false;
autodestroy := false;
end;

procedure tglrecolorer.recolorto(r,g,b,u : single;recolortime : double);
begin
recoloring := true;
setcolor(r,g,b,u);
rectime := recolortime;
ltime := curtime;
starttime := curtime;
end;

procedure tglrecolorer.show;{ONLY NON VISIBLE RECOLORER IMPLEMENTED}
var p : tptrlitem;
e  : tglobj;
dt : double;
begin
if (curtime-starttime > rectime) and (recoloring) then
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 e := tglobj(p.ptr);
 if e.colorenabled then
 begin
e.setcolor(color[0],color[1],color[2],color[3]);
 end;
 p := tptrlitem(p.pn);
 end;
if autodestroy then destroyed := true;
recoloring := false;
end;

if recoloring then begin
dt := extended(curtime - ltime)/extended(extended(starttime-curtime)+rectime);
if dt > 1  then dt := 0.6;
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 e := tglobj(p.ptr);
 if e.colorenabled then
 begin
e.color[0] := e.color[0]+(color[0] - e.color[0])*dt;
e.color[1] := e.color[1]+(color[1] - e.color[1])*dt;
e.color[2] := e.color[2]+(color[2] - e.color[2])*dt;
e.color[3] := e.color[3]+(color[3] - e.color[3])*dt;
e.setcolor(e.color[0],e.color[1],e.color[2],e.color[3]);
 end;
 p := tptrlitem(p.pn);
 end;
 ltime := curtime;
 end;
end;

{ tglScaler }

procedure tglScaler.beginshow;
begin
glPushmatrix;
gltranslatef(xt,yt,zt);{OBJECT IS ROTATED,and it stayz on its place }
if xr <> 0 then glrotatef(xr,1,0,0);
if yr <> 0 then glrotatef(yr,0,1,0);
if zr <> 0 then glrotatef(zr,0,0,1);
glScalef(xf,yf,zf);
if colorenabled and not postcoloring then begin
if glcl_AMBIENT IN USCOLOR then glmaterialfv(glclFace,GL_AMBIENT,@color)
else glmaterialfv(glclFace,GL_AMBIENT,@ABLACKALPHA) ;
if glcl_DIFFUSE IN USCOLOR then glmaterialfv(glclFace,GL_DIFFUSE,@color)
else glmaterialfv(glclFace,GL_DIFFUSE,@AblackALPHA);

if glcl_SPECULAR IN USCOLOR then begin
glmaterialfv(glclFace,GL_SPECULAR,@color);
glmaterialf(glclFace,GL_SHININESS,baseshine);
end else if not specularsethide then
glmaterialfv(glclFace,GL_SPECULAR,@AblackALPHA);
if glcl_EMISSION in uscolor then glmaterialfv(glclFace,GL_EMISSION,@color);
if enhcolor <> nil then
begin
enhcolor.SHOW;
end;
end;
processlist;

end;

constructor tglScaler.create(aid: smallint; x, y, z, axf, ayf,
  azf: single);
begin
inherited create(aid,x,y,z);
xf := axf;yf := ayf;zf := azf;
end;


{ tglOnShow }

procedure tglOnShow.showself;
begin
event;
end;

{ tglRing }

constructor tglRing.create(aid: smallint; x, y, z, InnerRadius,
  outterradius,height: single; outCutOff: boolean);
begin
outrad := outterradius;inrrad := innerradius;
flatout := outCutoff;
h := height;
inherited create(aid,x,y,z);
end;

procedure tglRing.showself2;
var i : integer;
step,a : single;
xv,yv,yyf,xxf : single;
begin
step := 2*pi/basequal;
glBegin(gl_Quad_Strip);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glNormal3f(-xv,-yv,0);
glVertex3f(xv*inrrad,yv*inrrad,-h/2);
glVertex3f(xv*inrrad,yv*inrrad,h/2);
end;
glNormal3f(-1,0,0);
glVertex3f(inrrad,0,-h/2);
glVertex3f(inrrad,0,h/2);
glEnd;

if flatout then begin
yyf := (outrad-inrrad)/sqrt(sqr(outrad-inrrad)+sqr(h/2));
xxf := h/2/sqrt(sqr(outrad-inrrad)+sqr(h/2));
glBegin(gl_Quad_Strip);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glNormal3f(xxf*xv,xxf *yv,yyf);
glVertex3f(xv*inrrad,yv*inrrad,h/2);
glVertex3f(xv*outrad,yv*outrad,0);
end;
glNormal3f(xxf,0,yyf);
glVertex3f(inrrad,0,h/2);
glVertex3f(outrad,0,0);
glEnd;

glBegin(gl_Quad_Strip);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glNormal3f(xxf*xv,xxf *yv,-yyf);
glVertex3f(xv*outrad,yv*outrad,0);
glVertex3f(xv*inrrad,yv*inrrad,-h/2);
end;
glNormal3f(xxf,0,-yyf);
glVertex3f(outrad,0,0);
glVertex3f(inrrad,0,-h/2);
glEnd;
end
else begin
glBegin(gl_Quad_Strip);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glNormal3f(xv,yv,0);
glVertex3f(xv*outrad,yv*outrad,h/2);
glVertex3f(xv*outrad,yv*outrad,-h/2);
end;
glNormal3f(1,0,0);
glVertex3f(outrad,0,h/2);
glVertex3f(outrad,0,-h/2);
glEnd;

glBegin(gl_Quad_Strip);
glNormal3f(0,0,1);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glVertex3f(xv*inrrad,yv*inrrad,h/2);
glVertex3f(xv*outrad,yv*outrad,h/2);
end;
glVertex3f(inrrad,0,h/2);
glVertex3f(outrad,0,h/2);
glEnd;

glBegin(gl_Quad_Strip);
glNormal3f(0,0,-1);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glVertex3f(xv*outrad,yv*outrad,-h/2);
glVertex3f(xv*inrrad,yv*inrrad,-h/2);
end;
glVertex3f(outrad,0,-h/2);
glVertex3f(inrrad,0,-h/2);
glEnd;
end;

end;

procedure xglCone(h,r : single;sl : integer;b : boolean;smsh : boolean);
var cosa,sina : single;
i : integer;
nx,ny : single;
rr : single;
step : single;
begin
sina := sqrt(sqr(h)+sqr(r));
cosa := r/sina;
sina := h/sina;
step := pi*2/sl;
if not b then cosa := -cosa;
glBegin(gl_TRIANGLE_FAN);
if not b then glNormal3f(0,0,-1)
else glNormal3f(0,0,1);
glVertex3f(0,0,h);
GlNormal3f(sina*r,0,cosa);
nx := 1;ny := 0;
for i := 1 to sl do
begin
if not smsh then begin
rr := step *(i+0.5);
glNormal3f(cos(rr)*sina,sin(RR)*sina,cosa);
end;
glvertex3f(nx*r,ny*r,0);
rr := step *(i);
nx := cos(rr);ny := sin(rr);
IF SMSH THEN glNormal3f(nx*sina,ny*sina,cosa);
glVertex3f(nx*r,ny*r,0);
end;
glEnd;
end;

procedure xglRing(inrrad,outrad,h : single;sl : integer;flatout : boolean);
var i : integer;
step,a : single;
xv,yv,yyf,xxf : single;
begin
step := 2*pi/basequal;
glBegin(gl_Quad_Strip);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glNormal3f(-xv,-yv,0);
glVertex3f(xv*inrrad,yv*inrrad,-h/2);
glVertex3f(xv*inrrad,yv*inrrad,h/2);
end;
glNormal3f(-1,0,0);
glVertex3f(inrrad,0,-h/2);
glVertex3f(inrrad,0,h/2);
glEnd;

if flatout then begin
yyf := (outrad-inrrad)/sqrt(sqr(outrad-inrrad)+sqr(h/2));
xxf := h/2/sqrt(sqr(outrad-inrrad)+sqr(h/2));
glBegin(gl_Quad_Strip);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glNormal3f(xxf*xv,xxf *yv,yyf);
glVertex3f(xv*inrrad,yv*inrrad,h/2);
glVertex3f(xv*outrad,yv*outrad,0);
end;
glNormal3f(xxf,0,yyf);
glVertex3f(inrrad,0,h/2);
glVertex3f(outrad,0,0);
glEnd;

glBegin(gl_Quad_Strip);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glNormal3f(xxf*xv,xxf *yv,-yyf);
glVertex3f(xv*outrad,yv*outrad,0);
glVertex3f(xv*inrrad,yv*inrrad,-h/2);
end;
glNormal3f(xxf,0,-yyf);
glVertex3f(outrad,0,0);
glVertex3f(inrrad,0,-h/2);
glEnd;
end
else begin
glBegin(gl_Quad_Strip);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glNormal3f(xv,yv,0);
glVertex3f(xv*outrad,yv*outrad,h/2);
glVertex3f(xv*outrad,yv*outrad,-h/2);
end;
glNormal3f(1,0,0);
glVertex3f(outrad,0,h/2);
glVertex3f(outrad,0,-h/2);
glEnd;

glBegin(gl_Quad_Strip);
glNormal3f(0,0,1);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glVertex3f(xv*inrrad,yv*inrrad,h/2);
glVertex3f(xv*outrad,yv*outrad,h/2);
end;
glVertex3f(inrrad,0,h/2);
glVertex3f(outrad,0,h/2);
glEnd;

glBegin(gl_Quad_Strip);
glNormal3f(0,0,-1);
for i := 0 to basequal-1 do
begin
a := step *i;
xv := cos(a);yv :=sin(a);
glVertex3f(xv*outrad,yv*outrad,-h/2);
glVertex3f(xv*inrrad,yv*inrrad,-h/2);
end;
glVertex3f(outrad,0,-h/2);
glVertex3f(inrrad,0,-h/2);
glEnd;
end;

end;



{ tglEnhBlinker }

procedure tglEnhBlinker.addp(Item: Tlitem);
begin
inherited;
if not visible then
begin
  tglobj(item).enhcolor := self;
  tglobj(item).colorenabled := true;
end;
end;

procedure tglEnhBlinker.addr(Item: Tlitem);
begin
inherited;
if not visible then
begin
  tglobj(item).enhcolor := self;
  tglobj(item).colorenabled := true;
end;
end;

constructor tglEnhBlinker.create(aid: smallint; r, g, b, u: single;
  atime: double);
begin
inherited create(aid,0,0,0);
vector := -1;
bltime := atime;
ltime := curtime;
low := 0;
setcolor(r,g,b,u);
end;

procedure tglEnhBlinker.encolor;
var emf,d : double;
color1 : floatar4;
begin
glPushAttrib(GL_COLOR_MATERIAL);
d := curtime-ltime;
emf := d/bltime;
if vector = -1 then emf := 1 - emf;
if (curtime-ltime) > bltime then begin
ltime := curtime;
vector := -vector;
end;
if emf < low then emf := low;
color1[0] := color[0]*emf;
color1[1] := color[1]*emf;
color1[2] := color[2]*emf;
color1[3] := color[3]*emf;
glMaterialfv(glclFace,GL_EMISSION,@color1);
end;

procedure tglEnhBlinker.hidecolor;
begin glPopAttrib; end;

procedure tglEnhBlinker.kill(AID: SMALLINT);
begin
if not visible then tglObj(find(aid)).ENHCOLOR := NIL;
  inherited;
end;

procedure tglEnhBlinker.killall;
var p : tptrlitem;
begin
IF NOT visiBle then begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
 tglobj(P.PTR).enhcolor := NIL;
 p := tptrlitem(p.pn);
end;
end;
inherited killall;
end;

procedure tglEnhBlinker.show;
begin
if visible then begin
glPushMatrix;
gltranslatef(xt,yt,zt);{OBJECT IS ROTATED,and it stayz on its place }
if xr <> 0 then glrotatef(xr,1,0,0);
if yr <> 0 then glrotatef(yr,0,1,0);
if zr <> 0 then glrotatef(zr,0,0,1);
encolor;
processlist;
showself;
hidecolor;
glPopMatrix;
end;
end;
end.
