unit tglines09;

interface
uses graphics,glcl18,sysutils,lists;
const                                  {red}      {blue}     {green}  {yellow}
lcolors : array[0..7] of tcolor = ($0,$004444dd ,$00de4141,$0044dd22,$0044cccc,
{light blue} {puple}   {BROWN}
$00bb8888,  $00aa33aa,$001155AA);
(*
lcolors : array[0..6] of tcolor = ($0,$004444dd ,$00dd4444,$0044dd22,$0044cccc,
{light blue}{puple}
$00bb7777,  $00aa33aa);
*)
type
t9x9ar = array[1..9,1..9]  of shortint;
tballc = record
x,y,c : byte;
end;
TNext = array[1..3] of Tballc;
tglines = class(TOBJECT)
fld  : t9x9ar;{0 - nothing}
prev : t9x9ar;
path : t9x9ar;
kills: array[1..9,1..9] of boolean;
next,pnext,fnext : TNext;
undoallowed : boolean;
fx,fy,tx,ty : byte;
score : integer;{i hope it will not be exceeded ;-)}
count : word;
killed,newkilled : boolean;
state : (stFrom,stTO,stMOVE,stFinished);
procedure   init;virtual;
procedure   main(x,y : byte);virtual;
procedure   findpath;virtual;
function    check(x,y : shortint):boolean;virtual;
procedure   rnext;virtual;
procedure reachable;virtual;
procedure domove;virtual;
end;

tglBallJumper = class(tglobj)
sttime,stptime : double;
steps,cstep : byte;
xc,yc,txa,tya : shortint;
ball : tglobj;
lines : tglines;
constructor create(aid : smallint;glines : tglines;fx,fy,tx,ty:shortint;steptime:double);
procedure nextstep(xc,yc : shortint;var chx,chy : shortint);
procedure show;override;
end;

implementation

procedure tglines.domove;
var s : byte;
    i : byte;
begin
state := stMOVE;
findpath;
fld[tx,ty] := fld[fx,fy];
fld[fx,fy] := 0;
killed := check(tx,ty);
if not killed then begin
s := 0;
fnext := next;
pnext := next;
for i := 1 to 3 do
 if fld[next[i].x,next[i].y] = 0 then begin
 fld[next[i].x,next[i].y] := next[i].c;
 end else s := i;
 if s <> 0 then begin
 repeat next[s].x := random(9)+1;next[s].y := random(9)+1;
 until fld[next[s].x,next[s].y] =0;
 fnext[s] := next[s];
 fld[next[s].x,next[s].y] := next[s].c;
 end;
inc(count,3);
newkilled := false;
for i := 1 to 3 do
 newkilled := newkilled or check(next[i].x,next[i].y);
rnext;
end;
end;

procedure tglines.findpath;
procedure filterout(i : shortint);
var x,y : integer;
begin
for x := 1 to 9 do for y := 1 to 9 do
 if path[x,y] = i then path[x,y] := 0;
end;
var
xc,yc : byte;
xi,yi : shortint;
bf : boolean;
u : byte;
begin{IT IZ NOT OPTIMAL}
xc := tx;yc := ty;
while path[xc,yc] >0 do
begin
u := path[xc,yc];
filterout(u);
path[xc,yc] := u;
bf := false;
for xi := -1 to 1 do begin
 for yi := -1 to 1 do
 if ((xi=0) xor(yi=0)) and (xc+xi>0)and(xc+xi<10) and (yc+yi>0)
 and (yc+yi<10) and (path[xc+xi,yc+yi] = u-1) then begin
 xc := xc+xi;yc := yc+yi;bf := true;break;
 end;
 if bf then break;
 end;
end;
end;

procedure tglines.main(x, y: byte);
begin
case state of
stTO   : if path[x,y]>0 then begin tx := x;ty := y;domove;end
         else if fld[x,y]>0 then begin fx := x;fy := y;reachable;state := stTO;end;
stFrom : if fld[x,y] >0 then begin fx := x;fy := y;reachable;state := stTO;end;
end;
end;

procedure tglines.rnext;
var i : integer;
xx,yy : integer;
begin
if count > 78 then state := stFinished else
begin
pnext := next;
for i := 1 to 3 do
begin
repeat
xx := random(9)+1;yy := random(9)+1;
until fld[xx,yy] = 0;
fld[xx,yy] := -1;{subdue duals}
next[i].x := xx;next[i].y := yy;next[i].c := random(7)+1;
end;
for xx := 1 to 9 do
 for yy := 1 to 9 do if fld[xx,yy] = -1 then inc(fld[xx,yy]);
end;
end;

procedure tgLines.init;
var x,y : shortint;
begin
randomize;
for x := 1 to 9 do
 for y:= 1 to 9  do
  fld[x,y] :=0;
state := stFrom;
rnext;
for x :=1 to 3 do fld[next[x].x,next[x].y] := next[x].c;
count := 3;
score := 0;
rnext;
end;

procedure tglines.reachable;
var
 xi,yi,xd,yd : shortint;
 f           : boolean;
 tct         : shortint;
begin
for xi := 1 to 9 do for yi := 1 to 9 do path[xi,yi] :=0;
path[fx,fy] := 1;
f := false;
tct := 1;
repeat
f := false;
for xi := 1 to 9 do
 for yi := 1 to 9 do
 if path[xi,yi]=tct then
 begin
 for xd := -1 to 1 do
  for yd := -1 to 1 do
  if ((xd = 0) xor (yd = 0)) and (xi+xd > 0) and (yi+yd > 0) and (xi+xd<10) and (yi+yd<10)
   and (fld[xi+xd,yi+yd] =0) and (path[xi+xd,yi+yd]=0)  then
  begin
  path[xi+xd,yi+yd] := path[xi,yi] +1;
  f := true;
  end;
 end;
 inc(tct);
until (not f);
for xi := 1 to 9 do
 for yi := 1 to 9 do if path[xi,yi]>0 then dec(path[xi,yi]);
end;

function tgLines.check(x,y: shortint):boolean;
var
vx,vy : shortint;
matr : array[-1..1,-1..1] of integer;
xc,yc : shortint;
i : shortint;
kilsum : byte;
killed : boolean;

procedure gpace(xd,yd :  shortint);
begin
if matr[xd,yd] + matr[-xd,-yd]>= 4 then
begin
 xc := x+xd;yc := y+yd;
 while (xc>0) and (yc >0) and (xc<10) and (yc<10) and (fld[xc,yc] = i) do
 begin
 kills[xc,yc] := true;
 fld[xc,yc] := 0;
 dec(count);
 xc := xc + xd;yc := yc+yd;
 end;
xc := x-xd;yc := y-yd;
 while (xc>0) and (yc >0) and (xc<10) and (yc<10) and (fld[xc,yc] = i) do
 begin
 kills[xc,yc] := true;
 fld[xc,yc] := 0;
 dec(count);
 xc := xc -xd;yc := yc-yd;
 end;
 kilsum := kilsum+matr[xd,yd]+matr[-xd,-yd];
killed := true;
end;
end;

begin
killed := false;
kilsum := 0;
for vx := 1 to 9 do
 for vy := 1 to 9 do
 kills[vx,vy] := false;{CLEAR}
killed := false;
i := fld[x,y];
for vx := -1 to 1 do
 for vy := -1 to 1 do
 if (vx = 0) and (vy = 0) then else
 begin
 matr[vx,vy] := 0;
 xc := x+vx;yc := y+vy;
 while (xc>0) and (yc >0) and (xc<10) and (yc<10) and (fld[xc,yc] = i)do
 begin
 inc(matr[vx,vy]);
 xc := xc + vx;yc := yc+vy;
 end;
end;
gpace(-1,-1);
gpace(0,-1);
gpace(1,-1);
gpace(-1,0);
if killed then begin kills[x,y]:= true;fld[x,y] := 0;dec(count);
inc(kilsum);score:= score+(kilsum-4)*kilsum;
end;
result := killed;
end;

{ tglBallJumper }

constructor tglBallJumper.create(aid: smallint; glines: tglines; fx, fy,
  tx, ty: shortint; steptime: double);
  var jm : tgljumper;
begin
inherited create(aid,0,0,0);
stptime := steptime;
lines := glines;
steps := lines.path[tx,ty];
xc := fx;yc := fy;txa := tx;tya := ty;
ball := xglfind(mainobj,(ty-1)*11+tx + 2000);
nextstep(xc,yc,fx,fy);
jm := tglJumper.create(getfid(ball),0,0,0);
jm.autodestroy := true;
ball.add(jm);
jm.addr(ball);
jm.startmove(fx-xc,fy-yc,0,0,0,0,stptime);
jm.startjump(0,0,0.4);
sttime := curtime;
end;
procedure tglBallJumper.nextstep(xc,yc : shortint;var chx,chy : shortint);
var xi,yi : shortint;
begin
for xi := -1 to 1 do
 for yi := -1 to 1 do
 if ((xi = 0)xor(yi=0)) and (xc+xi>0) and (xc+xi<10) and (yc+yi>0) and
 (yc+yi<10) and (lines.path[xc+xi,yc+yi]=lines.path[xc,yc]+1) then
 begin
 chx := xc+xi;chy := yc+yi;
 exit;
 end;
 raise exception.Create('bug:no path found');
end;

procedure tglBallJumper.show;
var dt : double;
ccst   : integer;
jm     : tgljumper;
xx,yy  : shortint;
begin
dt := (curtime-sttime)/stptime;
if (dt > 100) or (dt <0) then dt := 100;
ccst := trunc(dt);
if ccst >= steps then begin ball.killall;
ball.setpos(txa-9/2-0.45,tya-9/2-0.45,0.8);
jm := tglJumper.create(getfid(ball),0,0,0);
jm.autodestroy := true;
ball.add(jm);
jm.addr(ball);
jm.stArtmove(0,0,-0.4,0,0,0,stptime);
jm.stArtjump(0,0,-0.4);
destroyed := true;
exit;
end;
if ccst >cstep then begin
while lines.path[xc,yc] < ccst do nextstep(xc,yc,xc,yc);
cstep := ccst;
ball.killall;
ball.setpos(xc-9/2-0.45,yc-9/2-0.45,0.8);
jm := tglJumper.create(getfid(ball),0,0,0);
jm.autodestroy := true;
ball.add(jm);
jm.addr(ball);
nextstep(xc,yc,xx,yy);
jm.startmove(xx-xc,yy-yc,0,0,0,0,stptime);
jm.startjump(0,0,0.2);
end;
end;

end.
