unit tgspots08;

interface
uses graphics,forms,sysutils,dialogs,classes;
 const
  gscolors : array[1..4] of tcolor = ($004444dd ,$00dd4444,$0044dd22,$0044cccc);
  namez : array[1..4] of string =('','','','');
  type
 visproc = procedure(p : pointer) of object;{MEANS TGSPOTS}
 crdproc = procedure(x,y : integer;p : pointer) of object;


 GsFld = array[1..11,1..9] of byte;
 gsboolfld = array[1..11,1..9] of boolean;
 tscoretable = array[1..4] of byte;
 plyr = record
 score : byte;
 tp : (comp,hum,none);
 cuttst : boolean;
 gl :   byte;
 vlvl   : boolean;
 end;

 TGspots = class
 freeblocks : byte;
 deffld : boolean;
 sfld : gsfld;
 enbld : gsboolfld;
 curprgrs,maxprgrs : integer;
 players : array[1..4] of plyr;
 checks : longint;
 shx,shy,shx1,shy1 : integer;
 mx,my : integer;
 glubina : integer;
 cuttst : boolean;
 fl : Gsfld;
 victory,ready : boolean;
 c,h : integer;
 mode : (wfn{wait for new},hmovfromm,hmovtom,cmv,scmvm,swin);
 curplr,maxplr : byte;
 score : tscoretable;
 vlvl : boolean;
 shwdelay : boolean;
 amessage : string[80];
 onbegingame,
 onshwfl{i},onwrtsht{i},onmessage{i}, onshowcurplr{i},onthinkprogress{i},onhidefld{i},onhideselection{I??}, onmove{i},ondebug : visproc;
 onenl{i},onshowwinner{i}{,onshowactive} : crdproc;

   constructor create;
 { destructor destroy; virtual;}
  procedure cancel;virtual;
  procedure wrtmessage(s : string);virtual;
  function  getsum(st : tscoretable) : smallint;virtual;
  function  getscore(st : tscoretable;cv : byte) : smallint;virtual;
  procedure nextplr;virtual;
  procedure Init(ax,ay : integer);virtual;
  PROCEDURE initf;  {INITIALIZE FIELD}virtual;
  PROCEDURE rulmov(x,y,x1,y1 : integer;var ffz : gsFld;var st : tscoretable);virtual;
  FUNCTION tstc(ff : gsfld;gl : byte;plyr : byte;
   cv : byte;scortab : tscoretable): integer; virtual;
  function incplr(plrr : byte) : byte;          virtual;
  PROCEDURE twnr; {TEST WINNER}virtual;
  PROCEDURE cmov;       {COMPUTER'S MOVE}virtual;
  procedure scmv;    {Show computer's move}      virtual;
  PROCEDURE hmovto(x,y : integer);  {HUMAN'S MOVE}       virtual;
  procedure hmovfrom(x,y : integer);           virtual;
  PROCEDURE hmovs;  {HUMAN'S MOVE}    virtual;
  procedure Main(x,y : integer);  {intercept out calls}virtual;
  procedure showmove(ax,ay,axt,ayt : integer;alower : boolean);virtual;
  procedure debugmess(m : string);
  procedure incdep(s : string);
  procedure decdep;
  end;

 pmove = ^amove;
 amove = record
 pspots : tgspots;
 xf,yf,xto,yto : integer;
 lower : boolean;{TRUE - AUTOLOWER}
 end;

 var
  wins : array[1..4] of smallint = (0,0,0,0);
  tflag : boolean = false;
  app : tapplication;
  time1,time2 : double;
  forcekill : boolean = false;
  curdep : integer = 0;
  startme : boolean = false;
  lastcall : string;
implementation

 {G S P O T S}

 procedure tgspots.incdep(s : string);
 begin
{ if s <> 'CREATE' then  debugmess(s);}
 lastcall := s;
 inc(curdep);
 if curdep > 3000 then begin
{ raise exception.create('INFINIT GAME');}
 tflag := true;
 end;
 end;
 procedure tgspots.decdep;
 begin
 dec(curdep);
 if curdep < 0 then raise exception.Create('DEPTH IS NEG');
 end;

 procedure tgspots.debugmess(m : string);
 begin amessage := m;ondebug(self);app.processmessages;
 end;

 procedure tgspots.wrtmessage(s : string);
 begin  amessage := s;  onmessage(self); app.processmessages; end;

 procedure tgspots.showmove(ax,ay,axt,ayt : integer;alower : boolean);
 var p : pmove;  begin  new(p);  with p^ do    begin  xf := ax;
 yf := ay;xto := axt;yto := ayt; lower := alower; pspots := self;
 end;  onmove(p); app.processmessages; end;

 constructor tgspots.create;
 var x,y : integer;
 begin
 incdep('CREATE');;
 inherited create;
 for x := 1 to 11 do
 for y := 1 to 9 do
 enbld[x,y] := true;
 decdep;
 end;

 procedure tgspots.nextplr;
 var x,y,x1,y1 : integer;
 end1 : boolean;
 begin
 if victory or app.terminated then exit;
 incdep('NEXTPLR');
 curplr := incplr(curplr);
 end1 := false;
 if curplr > maxplr then curplr := 1;
 for x := 1 to mx do
 for y := 1 to my do
 if fl[x,y] = curplr then
  for x1 := -2 to 2 do
  for y1 := -2 to 2 do
  if ((x1 + x) > 0) and ((x1+x) <= mx) and ((y1 + y) > 0)
  and ((y1+y) <= my) and ((x1 <> 0) or (y1 <> 0))then
  if (fl[x1+x,y1+y] = 0 ) and enbld[x1+x,y1+y] then begin end1 := true; break;end;
if not(end1) then begin
onshwfl(self);
app.processmessages;
onwrtsht(self);
app.processmessages;
twnr;
wrtmessage('NO MOVES');
nextplr;
decdep;
exit;
end;
onshowcurplr(self);
app.processmessages;

if tflag then
begin
{debugmess('NEXTPLR WAS ABORTED: '+ inttostr(curplr));}
decdep;
exit;
end;

case players[curplr].tp of
comp : begin
{debugmess('IN NEXTPLR CMOV WAS CALLED: '+ inttostr(curplr));}
cuttst := players[curplr].cuttst; glubina := players[curplr].gl;
vlvl := players[curplr].vlvl; mode := cmv; cmov;
end;
hum  : hmovs;
none : begin
{debugmess('IN NEXTPLR NONE WAS CALLED: '+ inttostr(curplr));}
nextplr;
end;
end;
decdep;
end;


procedure tgspots.Main(x,y : integer);
begin
if curdep > 0 then begin debugmess('UDODISH CALL TO MAIN');exit;end;
if (mode = wfn) or victory then  exit;{raise exception.create('MAIN WAS CALLED ILLEGALY');}
{if curdep > 0 then raise exception.create('FUCKING CALL TO TGSPOTS.MAIN');}
incdep('MAIN');
{debugmess('MAIN :' +inttostr(curplr));}
if (x < 0) or (y < 0) or (x > mx) or (y > my) then begin decdep;exit;end;
if mode = scmvm then begin scmv; decdep;exit; end;
if mode = hmovtom then  begin hmovto(x,y); decdep;EXIT; end;
if mode = hmovFROMM then begin hmovfrom(x,y); decdep;EXIT; end; decdep;end;

procedure tgspots.hmovs;
begin  {debugmess('HMOVS :'+inttostr(curplr));}
mode := hmovfromm; {wrtmess('From spot : '}end;

procedure tgspots.hmovfrom(x,y : integer);
var x1,y1 : integer;
end1 : boolean;
begin
{if curdep > 1 then raise  exception.Create('I HMOVFROM NONZERO DEPTH');}
incdep('HMOVFROM');
{debugmess('HMOVFROM :'+inttostr(curplr));}
if fl[x,y] <> curplr then begin decdep; exit; end;
{wrtmessage('To spot :');}
shx := x;  shy := y;
end1 := false;
  for x1 := -2 to 2 do
  for y1 := -2 to 2 do
  if ((x1 + shx) > 0) and ((x1+shx) <= mx)
	and ((y1 + shy) > 0)and((y1+shy) <=my) then
  if (fl[x1 + shx,y1 + shy] = 0) and enbld[x1+shx,y1+shy] then end1 := true;
if not(end1) then  begin  {cancel;} decdep;exit  end;
mode := hmovtom;

onenl(x,y,self);
decdep;
end;

PROCEDURE tgspots.hmovto(x,y : integer);  {HUMAN'S MOVE}
begin
incdep('HMOVTO');
{debugmess('HMOVTO :'+inttostr(curplr));}
if (x = shx) and (y = shy) then begin cancel;decdep;exit;end;
if fl[x,y] = curplr then begin onhideselection(self);app.ProcessMessages; hmovfrom(x,y);decdep; exit; end;
if (fl[x,y] = 0) and  enbld[x,y] then
if (abs(x - shx) < 3) and ( abs(y-shy) < 3) and
  ((abs(x - shx) > 0) or ( abs(y-shy) > 0)) then
  begin
  shx1 := x-shx; shy1 := y - shy;
  rulmov(shx,shy,shx1,shy1,fl,score);
  showmove(shx,shy,x,y,true);
  if tflag then begin decdep;exit end;
{ onshwfl(self);}
  onwrtsht(self);
  if tflag then begin decdep;exit end;
  twnr;
  mode := swin;
  nextplr;
  app.ProcessMessages;
  end;
  decdep;
end;


PROCEDURE tgspots.cmov;       {COMPUTER'S MOVE}
var
allmvs : word;
rr : word;
mvs : array[1..30,1..4] of integer;
lmv :word;
x,y,x1,y1,hx,hy,hx1,hy1 : integer;
fff : gsfld;
max,cur : integer;
scrtab : tscoretable;
movefld : gsboolfld;{array[1..11,1..9] of boolean;{!CH:GSFLD!}
sttime : double;
BEGIN
incdep('CMOV');
{debugmess('CMOV :'+inttostr(curplr));}
sttime := now;
if not(victory) then
begin
checks := 0; lmv := 0;
wrtmessage('I''m thinking');
max := -32000;
 movefld := enbld;
 allmvs := 0;
 for x := 1 to mx do
 for y := 1 to my do
 if fl[x,y] = curplr then
  for x1 := -2 to 2 do
  for y1 := -2 to 2 do
  if ((x1 + x) > 0) and ((x1+x) <= mx) and ((y1 + y) > 0)
  and ((y1+y) <= my) and ((x1 <> 0) or (y1 <> 0))  then
  if (fl[x1 + x,y1 + y] = 0) and enbld[x1+x,y1+y] then   inc(allmvs);
  maxprgrs := allmvs;
  onthinkprogress(self);
  app.processmessages;
 curprgrs := 0;
 for x := 1 to mx do
 for y := 1 to my do
 if fl[x,y] = curplr then
  for x1 := -2 to 2 do
  for y1 := -2 to 2 do
  if ((x1 + x) > 0) and ((x1+x) <= mx) and ((y1 + y) > 0)
  and ((y1+y) <= my) and ((x1 <> 0) or (y1 <> 0)) then
  if (fl[x1 + x,y1 + y] = 0) and enbld[x1+x,y1+y] then
  BEGIN
  inc(curprgrs);
  onthinkprogress(self);
  app.processmessages;
  if app.terminated or tflag then
  begin {debugmess('CMOV WAS ABORTED DUE TO TFLAG');}decdep; exit;
  end;
       if (abs(x1)<2) and (abs(y1) <2) then
        begin
        if not(movefld[x+x1,y+y1]) then continue; {WHERE???}
        movefld[x+x1,y+y1] := false;
        end;
	fff := fl;
        scrtab := score;
	rulmov(x,y,x1,y1,fff,scrtab);
	cur := tstc(fff,1,incplr(curplr),curplr,scrtab);
	if (cur = max) and (lmv < 30) then
	begin
{        debugmess('NEW LMV ');}
	inc(lmv);
	mvs[lmv,1] := x; 	mvs[lmv,2] := y;
	mvs[lmv,3] := x1;	mvs[lmv,4] := y1;
	end;
	if cur > max then
	begin
	 max := cur; 	 lmv := 0;
	 hx := x; 	 hy := y;
	 hx1 :=x1;	 hy1 :=y1;
	END;
  end;
if max > -32000 then begin
if lmv > 0 then begin
rr := random(lmv+1);
if rr <> 0 then begin
hx := mvs[rr,1];hy := mvs[rr,2];
hx1 := mvs[rr,3];hy1 := mvs[rr,4];
end;
end;
  if app.terminated or tflag or victory or(mode= wfn)  then
  begin
{  debugmess('CMOV WAS ABORTED JUST BEFORE MOVE'); }decdep;exit;
  end;
if curplr = 1 then time1 := time1 + now-sttime
 else time2 := time2 + now - sttime;
showmove(hx,hy,hx1+hx,hy1+hy,false);
  if tflag then begin decdep;exit end;
mode := scmvm;
shx := hx;shx1 := hx1;shy := hy;shy1 := hy1;
wrtmessage('My turn is :');
time2 := 0;
if not shwdelay then scmv;
end;END;
decdep;
end;

procedure tgspots.scmv;
begin
incdep('SCMV');
 rulmov(shx,shy,shx1,shy1,fl,score);

 onshwfl(self);  onwrtsht(self);app.processmessages;  twnr;
  if app.terminated or tflag or victory   then
  begin {debugmess('SCMV WAS ABORTED');}decdep; exit;    end;
  nextplr;
  decdep;
end;

procedure TGSPots.init(ax,ay : integer);
begin
incdep('INIT');
tflag := false;
debugmess('STARTING');
{tflag := false;}
randomize;
maxplr := 4;
curplr := 4;{random(2)+1;FIRST PLR WIll MOVE>>>}
onhidefld(nil);
app.processmessages;
victory := false;
mode := cmv;
initf;
nextplr;
decdep;
end;

PROCEDURE tgspots.initf;  {INITIALIZE FIELD}
VAR
x,y : integer;

function plrnum : byte;
var i1,i2 : byte;
begin
i1 := 0;
for i2 := 1 to 4 do
 if players[i2].tp <> none then inc(i1);
plrnum := i1;
end;

BEGIN
incdep('INITF');
freeblocks := 0;
for x := 1 to mx do
for y := 1 to my do
begin if enbld[x,y] then inc(freeblocks);  end;


if deffld then begin
for x := 1 to mx do
for y := 1 to my do
begin fl[x,y] := 0;enbld[x,y] := true;  end;

x := plrnum;
if x < 2 then
begin
messagedlg('    2 .',mTERROR,[mbOk],1);
victory := true;
mode := wfn;
decdep;
exit;
end;
for y := 1 to 4 do score[y] := 0;
IF X = 2 then
begin
y := incplr(0);
fl[1,1] := y;
fl[mx,my] := y;
score[y] := 2;
y := incplr(y);
fl[mx,1] := y;
fl[1,my] := y;
score[y] := 2;
end
else
begin
y := incplr(0);{FIRST}
fl[1,1] := y;
score[y] := 1;
y := incplr(y); {SECOND}
fl[mx,1] := y;
score[y] := 1;
y := incplr(y);{THIRD}
fl[mx,my] := y;
score[y] := 1;
if x >  3 then
begin
y := incplr(y);{FOURTH}
fl[1,my] := y;
score[y] := 1;
end;
end;
end
else
begin
fl := sfld;
for x := 1 to 4 do score[x] := 0;
for x := 1 to mx do
 for y := 1 to my do
  if fl[x,y] > 0 then inc(score[fl[x,y]]);
  if getsum(score) = 0  then
  begin
 messagedlg('-   ',mTERROR,[mbOk],1);
 victory := true;
 mode := wfn;
 decdep;
 exit;
  end;
end;

onbegingame(self);
onwrtsht(self);
app.processmessages;
decdep;
END;


PROCEDURE Tgspots.twnr; {TEST WINNER}
var
cur,sv : integer;

function thereisonlyone : byte;
var i1,i2 : byte;
fl : byte;
begin
fl := 0;
for i1 := 1 to maxplr do
 begin
 if score[i1] = 0 then begin fl := 0;continue;end;
 fl := i1;
 for i2 := 1 to maxplr do
  if (i1 <> i2) and (score[i2] <> 0 )then begin fl := 0;break end;
 if fl <> 0 then break;
 end;
if fl > 0 then cur := fl;
thereisonlyone := fl;
end;

function fwinner: byte;
var i,wnr,sco : byte;
begin
wnr := 0;
sco := 0;
for i := 1 to maxplr do
 if score[i] > sco then begin
 wnr := i;
 sco := score[i];
 end;
for i := 1 to maxplr do
 if (i <> wnr) and (sco = score[i]) then begin wnr := 0;break;end;
fwinner := wnr;
end;

begin
incdep('TWNR');
sv := freeblocks - getsum(score);{SVCBODN}
if sv = 0 then
begin {NET SVOBODNIH}
cur := fwinner;
if cur = 0 then wrtmessage(' .')
else wrtmessage(namez[cur]+'  !!!');
mode := wfn;victory := true;
{form1.shape1.brush.color := gscolors[cur];}
onshowwinner(cur,0,self);
if cur <> 0 then inc(wins[cur]);
ONwrtsht(self);
app.ProcessMessages;
end
else if thereisonlyone > 0 then
begin
wrtmessage(namez[cur]+'   !!!!!');
mode := wfn;victory := true;
onshowwinner(cur,0,self);
{form1.shape1.brush.color := gscolors[cur];}
inc(wins[cur]);
onwrtsht(self);
app.ProcessMessages;
end; decdep;END;

PROCEDURE tGspots.rulmov(x,y,x1,y1 : integer;var ffz : Gsfld;var st : tscoretable);
var {HOD PO PRAVILAM IZ (x,y) V (x+x1,y+y1)}
xx,yy : integer; sv : byte;
procedure invrt;
var x2,y2 : shortint; {INVERT ENEMY'S SPOTS}
BEGIN
for x2 := -1 to 1 do
 for y2 := -1 to 1 do
if ((x2 + xx) > 0) and ((x2+xx) <= mx) and ((y2 + yy) > 0)
and ((y2+yy) <= my) and ((x2 <> 0) or (y2 <> 0)) then
if (ffz[x2+xx,y2+yy] > 0) and (ffz[x2+xx,y2+yy] <> sv) then
begin dec(st[ffz[x2+xx,y2+yy]]); inc(st[sv]); ffz[x2+xx,y2+yy] := sv;
end; end;
BEGIN
xx := x + x1; yy := y + y1; sv := ffz[x,y];
if (abs(x1) < 2) and (abs(y1) < 2) then
BEGIN{SHORT JUMP}  ffz[xx,yy] := sv;   inc(st[sv]); invrt; END
else BEGIN{LONG JUMP} ffz[xx,yy] := sv; ffz[x,y] := 0; invrt; end; END;

function tgspots.incplr(plrr : byte) : byte;
begin repeat  inc(plrr); if plrr > maxplr then plrr := 1;
until players[plrr].tp <> none; incplr := plrr; end;

function tgspots.getsum(st : tscoretable):smallint;
var i : byte; ss : smallint;
begin  ss := st[1]; for i := 2 to maxplr do ss := ss + st[i];
getsum := ss; end;

function tgspots.getscore(st : tscoretable;cv : byte{FOR WHOME}): smallint;
begin getscore := st[cv]+st[cv]-getsum(st); end;

 {STRATEGY TEST}
FUNCTION tgspots.tstc(ff : gsfld{FIELD};gl : byte{DEPTH};plyr : byte{MOVING PLAYER};cv : byte{THAT WHO REALY MOVES};
scortab : Tscoretable{SCORE}): integer;{MIN/MAX SCORE}
var cutrnd {,allmvs},cutvalue : integer; {USED IN CUTTING}
mv : boolean; x,y,x1,y1,min,cur : integer;{TO STORE COORDINATES}
fff : gsfld;{FIELD} scortab1 : tscoretable;
movefld : gsboolfld;{array[1..11,1..9] of boolean;{!CH:GSFLD!}{TO PREVENT SAME MOVES}

function hasmoves(apl : byte) : boolean;
var x,y,x1,y1 : integer;
begin
for x := 1 to mx do
 for y := 1 to my do
if ff[x,y] = apl then
 for x1 := -2 to 2 do                                                  {}
 for y1 := -2 to 2 do                                                  {}
 if ((x1 + x) > 0) and ((x1+x) <= mx) and ((y1 + y) > 0)               {}
  and ((y1+y) <= my) and ((x1 <> 0) or (y1 <> 0)) then                 {}
 if (ff[x1 + x,y1 + y] = 0) and enbld[x1+x,y1+y] then begin hasmoves := true;exit end;
 hasmoves := false;                                        {}
end;

function tryend : integer;
var
ccp,movers : byte;

begin
ccp := plyr;
movers := 0;
repeat
ccp := incplr(ccP);
if ccp <> plyr then if hasmoves(ccp) then inc(movers);
until ccp = plyr;
if movers=0 then raise exception.create('UNKNOWN SITUATION IN TSTC > TRYEND');
if movers=1 then
begin
ccp := plyr;
repeat
ccp := incplr(ccP);
until HasMoves(CCP);
scortab[ccp] := scortab[ccp] +(freeblocks - getsum(scortab));
tryend := getscore(scortab,cv);
exit;
end;
tryend := tstc(ff,gl,incplr(plyr),cv,scortab);
end;

BEGIN
inc(checks);
if gl = glubina then begin tstc := getscore(scortab,cv);exit; end;
if tflag then BEGIN TSTC := 0; exit;END;
if scortab[plyr] = 0 then begin tstc := tstc(ff,gl,incplr(plyr),cv,scortab); exit; end;
if scortab[cv] = 0 then begin   tstc := -freeblocks; exit; end;
if getsum(scortab)-scortab[cv] = 0 then BEGIN tstc := freeblocks; exit; end;
{if getsum(scortab)-scortab[plyr] = 0 then BEGIN tstc := -freeblocks; exit; end;}
if getsum(scortab) = freeblocks then begin tstc := getscore(scortab,cv); exit; end;

if random(10000) = 5359 then
begin
app.processmessages;
if app.Terminated then begin
tflag := true;
debugmess('TSTC MODIFIED TFLAG TO TRUE');
tstc := 0;
exit;
end;
end;

movefld := enbld;

mv := false;
if (plyr = cv) then begin min := -freeblocks; end
 else begin  min := freeblocks; end;

{if cuttst or (vlvl and (gl = glubina-1)) then {INIT CUTTING}
{begin
allmvs := 0;
for x := 1 to mx do
for y := 1 to my do
if ff[x,y] = plyr then
begin {-----------------------------------------------------------------}
{ for x1 := -2 to 2 do                                                  {}
{ for y1 := -2 to 2 do                                                  {}
{ if ((x1 + x) > 0) and ((x1+x) <= mx) and ((y1 + y) > 0)               {}
{  and ((y1+y) <= my) and ((x1 <> 0) or (y1 <> 0)) then                 {}
{ if (ff[x1 + x,y1 + y] = 0) and enbld[x1+x,y1+y] then inc(allmvs);                                        {}
{end;
if allmvs > 5 then cutvalue:=round(10*(allmvs/((allmvs-5)*(1.3/gl)+5)))
else cutvalue := 2 ;}
{
if vlvl and (gl = glubina-1) and (allmvs > 8) then cutvalue := round(10*allmvs/8);
end
else cutvalue := 2;}
cutvalue := gl;{IF GL > 12 then F U C K !!!!'}
{M A I N}

for x := 1 to mx do
for y := 1 to my do
if ff[x,y] = plyr {MAYBE ITS EQ}{cn} then
begin {-----------------------------------------------------------------}
 for x1 := -2 to 2 do                                                  {}
 for y1 := -2 to 2 do                                                  {}
 if ((x1 + x) > 0) and ((x1+x) <= mx) and ((y1 + y) > 0)               {}
  and ((y1+y) <= my) and ((x1 <> 0) or (y1 <> 0)) then                 {}
 if (ff[x1 + x,y1 + y] = 0)  and enbld[x1+x,y1+y] then
 begin
 cutrnd := random(cutvalue);
 if cutrnd <= 14 then
 begin                                                               {}
 if (plyr = cv) then                                                          {}
 begin {-----------------------------------------}                     {}
 if  (abs(x1)<2) and (abs(y1) <2) then
 begin
 if not(movefld[x+x1,y+y1]) then continue; {WHERE???}
 movefld[x+x1,y+y1] := false;
 end;
 if cuttst then inc(cutvalue);
 fff := ff;                                     {}                     {}
 scortab1 := scortab;
 mv := true;                                    {}                     {}
 rulmov(x,y,x1,y1,fff,scortab1);                {}                     {}
 cur := tstc(fff,gl+1,incplr(plyr),cv,scortab1);{}                     {}
  if cur > min then min := cur;                 {}                     {}
 END   {-----------------------------------------}                     {}
 else                                                                  {}
 begin {-----------------------------------------}                     {}
  if  (abs(x1)<2) and (abs(y1) <2) then
 begin
 if not(movefld[x+x1,y+y1]) then continue; {WHERE???}
 movefld[x+x1,y+y1] := false;
 end;
if cuttst then  inc(cutvalue);
 fff := ff;                                     {}                     {}
 scortab1 := scortab;
 mv  := true;                                   {}                     {}
 rulmov(x,y,x1,y1,fff,scortab1);                {}                     {}
 cur := tstc(fff,gl+1,incplr(plyr),cv,scortab1);{}                     {}
 if cur < min then min := cur;                  {}                     {}
 END; {------------------------------------------}                     {}
 end;
 end;
END;  {-----------------------------------------------------------------}

if not(mv) then  begin
if vlvl then begin
min := getscore(scortab,cv);
{debugmess('TRYEND MODIFIES : ' + inttostr(min));}
 min := tstc(ff,gl,incplr(plyr),cv,scortab);{TRYEND}
{debugmess(' TO : ' + inttostr(min));}
end else min := getscore(scortab,cv);
  end;
tstc := min;
END;

procedure TGspots.CANCEL;
begin  mode := hmovfromm; onhideselection(self);app.processmessages;  end;

end.
