//aleX
//declaration TLItem,TList and TContainer classes
//that are used in GLCL,TC and other programs
//if u want use standart Lists place this unit before Classes
// sensitive to LDEBUG define
// if u want use interfaces define LINTERF
// if u need counting REFCOUNT,use LINTERFCOUNTREFS
{$DEFINE LINTERF}
unit lists;//P R O T E C T E D containers !!! : 17.01.00
// ordered list
interface
uses sysutils,classes;
type
TLItem = class({$IFDEF LINTERF}
TINTERFACEDOBJECT
{$ELSE}
TOBJECT
{$ENDIF}
)
Pn : TLItem;    {NEXT}
Id : smallint;
constructor Create(AId : smallint);{ virtual;}
{$IFNDEF LINTERFCOUNTREF}
function _addref : integer;stdcaLL; {DONTcare}
function _release : integer;stdcaLL;{DONTcare}
{$ENDIF}
{$IFDEF LDEBUG}
public
    destructor destroy; override;
{$ENDIF}
end;

getproc = procedure (Item : TLItem) of object;

tlist = class(TLItem)
Pf : Tlitem;    {FIrst ItEm}
Count : Smallint; {NumbeR of ItEMs}
constructor Create(AId : smallint);
function Find(aId: smallint) : tLItem;virtual;
procedure Kill(aId : smallint);virtual;
procedure Add(Item : TLItem);virtual;
procedure KillAll;virtual;
procedure GiveAllTo(proc : getproc);
Destructor Destroy ; override;
end;

torderedList = class(tlist)
procedure kill(aid : smallint);override;
procedure add(item : tlitem);override;
procedure shift(fid : smallint;sh : smallint);virtual;
end;



tptrLitem = class(tlitem)
ptr : tlitem;
replica : boolean;
protectionobj : tlitem;
constructor create(p : tlitem;rep : boolean);
destructor destroy;override;
end;

tcontainer = class(TLItem)
pf : Tlist;
pl : Tlist;
count : smallint;
constructor create(aid : smallint);
function Find(aId: smallint) : tLItem;virtual;
procedure Kill(aId : smallint);virtual;
procedure Add(Item : TLItem);virtual;
procedure Addr(item : TLitem);virtual;{ADDS REPLICA}
procedure addp(item : tlitem);virtual;{ADds replica,BUG-PROTECTED}
procedure addprotect(item : tcontainer);virtual;{PROTECTION LIST}
procedure decProtect(item : tcontainer);virtual;
procedure KillAll;virtual;
{procedure GiveAllTo(proc : getproc);}
Destructor Destroy ; override;
end;

function xfind(obj : pointer;id : smallint) : tlitem;
function getfid(obj : tobject) : smallint;overload;
function getfid(obj : tobject;fid : smallint) :smallint;overload;
function getfid(obj : tobject;fid,lid : smallint) : smallint;overload;
procedure contMoveToStart(c : tcontainer;aid : smallint);
procedure contMoveToEnd(c : tcontainer;aid : smallint);

{$IFDEF LDEBUG}
var
LDONCREATE : tnotifyevent;
LDONDESTROY : tnotifyevent;
{$ENDIF}

implementation
procedure contMoveToEnd(c : tcontainer;aid : smallint);
var pp,ps,ls: tlitem;
begin
if c.pf.count <2 then exit;
pp := c.pf.pf;
ls := pp;
while (ls.pn <>nil) do ls := ls.pn;
if ls.id = aid then exit;{ITS ALREADY LAST}
ps := nil;
while (pp <> nil)  do
begin
if pp.id = aid then break;
ps := pp;
pp := pp.pn;
end;
if (pp = nil)  then exit;
if ps <> nil then
ps.Pn := pp.pn
else c.pf.pf := pp.Pn;
ls.pn := pp;
pp.pn := nil;
end;

procedure contMoveToStart(c : tcontainer;aid : smallint);
var pp,ps: tlitem;
begin
if c.pf.count <2 then exit;
pp := c.pf.pf;
if pp = nil then exit;
if pp.id = aid then exit;{its already in front}
ps := nil;
while (pp <> nil)  do
begin
if pp.id = aid then break;
ps := pp;
pp := pp.pn;
end;
if (pp = nil) or (ps = nil) then exit;
ps.Pn := pp.pn;
pp.pn := c.pf.pf;
c.pf.pf := pp;
end;

function getfid(obj : tobject) : smallint;
begin
getfid := getfid(obj,-32768,32767);
end;
function getfid(obj : tobject;fid : smallint) :smallint;overload;
begin
getfid := getfid(obj,fid,32767);
end;
function getfid(obj : tobject;fid,lid : smallint) : smallint;overload;
var x : integer;
begin
if obj = nil then raise exception.create('NIL in getfid');
if obj is tcontainer then
begin
for x := fid to lid do
 if tcontainer(obj).find(x) = nil then
 begin getfid := x;exit end;
end
 else
 if obj is tlist then
 for x := fid to lid do
 if tlist(obj).find(x) = nil then
 begin getfid := x;exit end;
raise exception.create('THERE ARE NO FREE IDS IN GIVEN OBJ or OBJ is invalid');
end;
function xfind(obj : pointer;id : smallint): tlitem;
begin
if obj = nil then xfind := nil else
xfind := tlist(obj).find(id);
end;
{$IFDEF LDEBUG}
destructor tLItem.destroy;
begin
if assigned(LDONDESTROY) then ldondestroy(self);
end;
{$ENDIF}

procedure torderedlist.add(item : tlitem);
var p : tlitem;
begin
if item.id > count+1 then item.id := count+1;
if item.id = count+1 then begin inherited add(item);exit; end;
shift(item.id,+1);
p := find(item.id+1);
item.Pn := p.pn;
p.pn := item;
inc(count);
end;

procedure torderedlist.kill(aid : smallint);
begin
inherited kill(aid);
shift(aid,-1);
end;

procedure torderedlist.shift(fid : smallint;sh : smallint);
var p : tlitem;
begin
p := pf;
while (p<> nil) and (p.id >= fid) do
begin
p.id := p.id + sh;
p := p.pn;
end;

end;


procedure tcontainer.addprotect(item : tcontainer);
begin
if pl = nil then pl := tlist.Create(0);
pl.add(tptrlitem.create(item,true));
end;

procedure tcontainer.decprotect(item : tcontainer);
var
pp,pll : tptrlitem;
begin
if pl = nil then raise exception.Create('ADDP PROTECTION FAULT');
if pl.pf = nil then raise exception.Create('ADDP PROTECTION FAULT');
if tptrlitem(pl.pf).ptr = item then
begin
pp := tptrlitem(pl.pf.pn);
pl.Pf.destroy;
dec(pl.count);
pl.Pf := pp;
exit;
end;

pll :=tptrlitem(pl.pf);
pp := tptrlitem(pl.pf.pn);
while pp <> nil do
if pp.ptr  = item then
begin
pll.Pn := pp.Pn;
pp.free;
dec(pl.count);
exit;
end
else
begin
pll := pp;
pp := tptrlitem(pp.pn);
end;

end;

procedure tcontainer.KillAll;
begin
if (pf = nil) or(pf.pf = nil) then exit;
pf.destroy;
pf := tlist.Create(id);
{if pl <> nil then if pl.count = 0 then pl.free;}
count := pf.Count;
end;

constructor tptrlitem.create(p : tlitem;rep : boolean);
begin
if p = nil then raise exception.create('NIL WAS ADDED');
inherited create(p.id);
ptr := p;
replica := rep;
protectionobj := nil;
end;

destructor tptrlitem.destroy;
begin
if not replica then ptr.free;
if protectionobj <> nil then tcontainer(ptr).decprotect(tcontainer(protectionobj));
inherited destroy;
end;



procedure tcontainer.addp(item : tlitem);
var
nn : tptrlitem;
begin
nn := tptrlitem.create(item,true);
nn.protectionobj := self;
tcontainer(item).addprotect(self);
pf.add(nn);
count := pf.Count;
end;

constructor tcontainer.create(aid : smallint);
begin
inherited create(aid);
pf := tlist.create(aid);
pl := nil;
count := pf.Count;
end;

function tcontainer.Find(aId: smallint) : tLItem;
var
p : tptrlitem;
begin
p :=  tptrlitem(pf.Find(aid));
if p <> nil then find := p.ptr else find := nil;
end;

procedure tcontainer.Kill(aId : smallint);
begin
pf.kill(aid);
count := pf.Count;
end;
procedure tcontainer.Add(Item : TLItem);
begin
pf.add(tptrlitem.create(item,false));
count := pf.Count;
end;
procedure tcontainer.AddR(item : TLitem);
begin
pf.add(tptrlitem.create(item,true));
count := pf.Count;
end;

{procedure GiveAllTo(proc : getproc);}
Destructor tcontainer.Destroy ;
var
pp,pp1 : tptrlitem;
begin
if pl <> nil then
begin
pp := tptrlitem(pl.pf);
while not (pp = nil) do
begin
pp1 := tptrlitem(pp.pn);
tcontainer(pp.ptr).kill(id);{!@#$%^&*&%##!!!}
pp := pp1;
end;
pl.destroy;
end;
killall;{LITTLE SLOWER,BUT ...}
pf.free;
inherited destroy;
end;




constructor tLItem.Create(Aid : smallint);
begin inherited create;
id := AID;pn := nil;
{$IFDEF LDEBUG}
if assigned(LDonCREATE) then LDONCREATE(self);
{$ENDIF}
end;

constructor TList.Create(aid  : smallint);
begin
pf := nil;
count := 0;
Inherited create(AID);
end;

destructor tlist.destroy;
var p : tlitem;
begin
while pf <> nil do
 begin
 p := pf.pn;
 pf.free;
 pf := p;
 end;
inherited destroy;
end;


procedure tlist.giveallto(proc : getproc);
var i : tlitem;
begin
i := pf;
while i <> nil  do
 begin
 proc(i);
 i := i.pn;
 end;
end;

function tlist.find(aid : smallint): tlitem ;
var pp : tlitem;
begin
{if aid = id then
begin
find := addr(self);
exit;
end;}
pp := pf;
while (pp <> nil)  do
begin
if pp.id = aid then break;
pp := pp.pn;
end;
find := pp;
end;

procedure tlist.kill(aid : smallint);
var pp,pl : tlitem;
begin
if pf = nil then exit;
while (pf.Id = aid)  do
 begin
 pp := pf.Pn;
 pf.Free;
 dec(count);
 pf := PP;
 if pf = nil then exit;
 end;
pl :=pf;
pp := pf.pn;
while pp <> nil do
if pp.Id = Aid then
begin
pl.Pn := pp.Pn;
pp.free;
dec(count);
pp := pl.pn;
end
else
begin
pl := pp;
pp := pp.pn;
end;
end;

procedure tlist.add(Item : Tlitem);
begin {No LOW - MEM WARNING}
if item = nil then exit;
item.pn := pf;
pf := item;
inc(count);
end;


procedure tlist.KillAll;
var p : tlitem;
begin
while pf <> nil do
 begin
 p := pf.pn;
 pf.free;
 pf := p;
 end;
 count := 0;
end;
{$IFNDEF LINTERFCOUNTREF}
function TLItem._addref : integer;
begin
result := -1;
end;
function TLItem._Release : integer;
begin
result := -1;
end;
{$ENDIF}
end.
